DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP > Class Template Referenceabstract

_ More...

`#include <gfpcrypt.h>`

Inheritance diagram for DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >:

## Public Types

typedef GROUP_PRECOMP::Element | Element
typedef GROUP_PRECOMP | GroupPrecomputation
typedef BASE_PRECOMP | BasePrecomputation

## Public Member Functions

bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
void | AssignFrom (const NameValuePairs &source)
| assign values from source to this object More...
const DL_FixedBasePrecomputation < Element > & | GetBasePrecomputation () const
DL_FixedBasePrecomputation < Element > & | AccessBasePrecomputation ()
const Integer & | GetModulus () const
const Integer & | GetGenerator () const
void | SetModulusAndSubgroupGenerator (const Integer &p, const Integer &g)
bool | operator== (const DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP > &rhs) const
bool | operator!= (const DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP > &rhs) const
const DL_GroupPrecomputation < Element > & | GetGroupPrecomputation () const
void | Initialize (const DL_GroupParameters_IntegerBased &params)
void | Initialize (RandomNumberGenerator &rng, unsigned int pbits)
void | Initialize (const Integer &p, const Integer &g)
void | Initialize (const Integer &p, const Integer &q, const Integer &g)
void | BERDecode (BufferedTransformation &bt)
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
void | DEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
const Integer & | GetSubgroupOrder () const
Integer | GetGroupOrder () const
bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const
bool | ValidateElement (unsigned int level, const Integer &element, const DL_FixedBasePrecomputation< Integer > *precomp) const
bool | FastSubgroupCheckAvailable () const
void | EncodeElement (bool reversible, const Element &element, byte *encoded) const
unsigned int | GetEncodedElementSize (bool reversible) const
Integer | DecodeElement (const byte *encoded, bool checkForGroupMembership) const
Integer | ConvertElementToInteger (const Element &element) const
Integer | GetMaxExponent () const
OID | GetAlgorithmID () const
void | SetSubgroupOrder (const Integer &q)
void | Save (BufferedTransformation &bt) const
void | Load (BufferedTransformation &bt)
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER More...
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors More...
bool | SupportsPrecomputation () const
void | Precompute (unsigned int precomputationStorage=16)
| do precomputation More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
virtual const Element & | GetSubgroupGenerator () const
virtual void | SetSubgroupGenerator (const Element &base)
virtual Element | ExponentiateBase (const Integer &exponent) const
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
virtual Integer | GetCofactor () const
virtual bool | IsIdentity (const Element &element) const =0
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const =0
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| calls the above function with a NameValuePairs object that just specifies "KeySize"
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
void | DoQuickSanityCheck () const
template<class T >
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T >
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T >
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int More...
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const

## Static Public Member Functions

static std::string | StaticAlgorithmNamePrefix ()
static void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch

## Protected Member Functions

Integer | ComputeGroupOrder (const Integer &modulus) const
virtual int | GetFieldType () const =0
virtual unsigned int | GetDefaultSubgroupOrderSize (unsigned int modulusSize) const
void | ParametersChanged ()

## Protected Attributes

GROUP_PRECOMP | m_groupPrecomputation
BASE_PRECOMP | m_gpc

## Detailed Description

### template<class GROUP_PRECOMP, class BASE_PRECOMP = DL_FixedBasePrecomputationImpl< typename GROUP_PRECOMP::Element>>
class DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >

_

Definition at line 84 of file gfpcrypt.h.

## Member Function Documentation

template<class GROUP_PRECOMP, class BASE_PRECOMP = DL_FixedBasePrecomputationImpl< typename GROUP_PRECOMP::Element>>

void DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::AssignFrom | ( | const NameValuePairs & | source | ) |

inline virtual

assign values from source to this object

Note
  This function can be used to create a public key from a private key.

Reimplemented from DL_GroupParameters_IntegerBased.

Definition at line 95 of file gfpcrypt.h.

void DL_GroupParameters_IntegerBased::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) |  |

virtual inherited

parameters: (ModulusSize, SubgroupOrderSize (optional))

Reimplemented from GeneratableCryptoMaterial.

Reimplemented in DL_GroupParameters_DSA.

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const

inline virtual inherited

encode this object into a BufferedTransformation, using BER

this may be useful if DEREncode() would be too inefficient

Definition at line 1643 of file cryptlib.h.

bool DL_GroupParameters< Integer >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const

inline virtual inherited

check this object for errors

Parameters

  level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time

Returns
  true if the tests pass

Implements CryptoMaterial.

Definition at line 531 of file pubkey.h.

bool DL_GroupParameters< Integer >::SupportsPrecomputation | ( |  | ) | const

inline virtual inherited

Returns
  whether this object supports precomputation

Reimplemented from CryptoMaterial.

Definition at line 555 of file pubkey.h.

void DL_GroupParameters< Integer >::Precompute | ( | unsigned int | precomputationStorage = `16` | ) |

inline virtual inherited

do precomputation

The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation.

Reimplemented from CryptoMaterial.

Definition at line 557 of file pubkey.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) |  | const

inline inherited

get a named value with type int

used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case)

Definition at line 281 of file cryptlib.h.

The documentation for this class was generated from the following file:

- gfpcrypt.h